//+------------------------------------------------------------------+
//|                                                      _SET_BU.mq4 |
//|                      Copyright  2009, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright  2009, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"
//+------------------------------------------------------------------+
//| script program start function                                    |
//+------------------------------------------------------------------+
void start(){
  int stlw=MarketInfo(Symbol(),MODE_STOPLEVEL);
  int spr =MarketInfo(Symbol(),MODE_SPREAD);  
  double prise=WindowPriceOnDropped();
  if(prise==0){
    Alert("  !");
    return;
  } 
//----  
  for(int i=0;i<OrdersTotal();i++){
    if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES)){
      if(OrderSymbol()==Symbol()){
        if(OrderCloseTime()==0){
          if(MathAbs(OrderOpenPrice()-prise)<spr*Point*2){
            int ticket=OrderTicket();
          }
        }  
      }
    }
  }
  if(ticket<1){
    Alert("  !");
    return;  
  }
//----
  while(!IsStopped()){
    Sleep(300);
    if(ObjectFind("target")!=0){
      Alert("  ");
      return;
    }else{
      double target = nd(ObjectGet("target",OBJPROP_PRICE1));
    }
    if(OrderSelect(ticket,SELECT_BY_TICKET)){
      if(OrderType()>1){Alert("  ");return;}
      if(OrderCloseTime()!=0){Alert(" ");return;}
      if(OrderType()==OP_BUY){if(target<OrderOpenPrice()){Alert("   !");return;}}
      if(OrderType()==OP_SELL){if(target>OrderOpenPrice()){Alert("   !");return;}}
      if(NormalizeDouble(OrderOpenPrice(),Digits)==NormalizeDouble(OrderStopLoss(),Digits)){Alert(" ");return;}
      if(OrderType()==0){Comment("    = ",(target - Bid)/Point);  
        if(Bid>target){
          if(Bid-OrderOpenPrice()>stlw*Point){
            if(!OrderModify(ticket,OrderOpenPrice(),OrderOpenPrice(),OrderTakeProfit(),0,Blue)){
              Alert("   ",GetLastError());
              return;
            }else{PlaySound("expert.wav");}
          }  
        }
      }
      if(OrderType()==1){Comment("    = ",(Ask - target)/Point);  
        if(Ask<target){
          if(OrderOpenPrice()-Ask>stlw*Point){
            if(!OrderModify(ticket,OrderOpenPrice(),OrderOpenPrice(),OrderTakeProfit(),0,Blue)){
              Alert("   ",GetLastError());
              return;
            }else{PlaySound("expert.wav");}
          }  
        }        
      }        
    }
  }
return;}
//+------------------------------------------------------------------+
double nd(double in){return(NormalizeDouble(in,MarketInfo(Symbol(),MODE_DIGITS)));}