//+------------------------------------------------------------------+
//|                                                      _SET_TP.mq4 |
//|                      Copyright  2009, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright  2009, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"
#include <WinUser32.mqh>

//+------------------------------------------------------------------+
//| script program start function                                    |
//+------------------------------------------------------------------+
void start(){
  int stlw=MarketInfo(Symbol(),MODE_STOPLEVEL);
  int spr =MarketInfo(Symbol(),MODE_SPREAD);
  static int ticket;
  double prise=WindowPriceOnDropped();
  if(prise==0){
    Alert("  !");
    return;
  }    
  if(ObjectFind("order")!=0){
    Alert("  ");
    return;     
  }
  for(int i=0;i<OrdersTotal();i++){
    if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES)){
      if(OrderSymbol()==Symbol()){
        if(OrderCloseTime()==0){
          if(MathAbs(OrderOpenPrice()-prise)<spr*Point*2){
            ticket=OrderTicket();
          }  
        }
      }
    }
  }  
  if(ticket<1){
    Alert("  !");
    return;  
  }  
//---- 
  int tick;
  while(!IsStopped()&&tick>=0){ 
  double sl=NormalizeDouble(ObjectGet("order",OBJPROP_PRICE1),MarketInfo(Symbol(),MODE_DIGITS));  
  tick=-1;
  int res;
  for(i=0;i<OrdersTotal();i++){
    if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES)){
      if(OrderSymbol()==Symbol()){
        if(OrderCloseTime()==0){
          if(MathAbs(OrderOpenPrice()-prise)<spr*Point*2){
            tick=OrderTicket();
          }  
        }
      }
    }
  }  
  if(tick<1||ticket!=tick){
    Alert("  !");
    return;  
  }
  if(OrderSelect(tick,SELECT_BY_TICKET)){
    if(NormalizeDouble(OrderStopLoss(),Digits)==sl){
      Alert(" ");
      return;
    }
    if(OrderType()==1||OrderType()==3||OrderType()==5){
      RefreshRates();
      if(sl-Bid>stlw*Point){
        if(!OrderModify(tick,OrderOpenPrice(),sl,OrderTakeProfit(),0,White)){
          Alert("    ",GetLastError());
          return;
        }else{PlaySound("expert.wav");}
      }
      RefreshRates();
      if(sl-Bid<=stlw*Point){
          Comment("_SET_SL DISTANSE = ",DoubleToStr((sl-Bid)/Point,0));
          RefreshRates();
          if(sl-Bid<=0){
            if(OrderType()==1){
              res=MessageBox("   "+tick+"?",Symbol()+"  SET_SL",MB_OKCANCEL);
              if(res==IDCANCEL){return;}
              if(res==IDOK){
              RefreshRates();
              if(!OrderClose(tick,OrderLots(),Ask,spr,Red)){
                Print("  ",GetLastError());
              }else{PlaySound("expert.wav");}
              }
            }
          }
      }
    }
    if(OrderType()==0||OrderType()==2||OrderType()==4){
      RefreshRates();
      if(Ask-sl>stlw*Point){
        if(!OrderModify(tick,OrderOpenPrice(),sl,OrderTakeProfit(),0,White)){
          Alert("    ",GetLastError());
          return;
        }else{PlaySound("expert.wav");}
      }
      RefreshRates();
      if(Ask-sl<=stlw*Point){
          Comment("_SET_SL DISTANSE = ",DoubleToStr((Ask-sl)/Point,0));
          RefreshRates();
          if(Ask-sl<=0){
            if(OrderType()==0){
              res=MessageBox("   "+tick+"?",Symbol()+" SET_SL",MB_OKCANCEL);
              if(res==IDCANCEL){return;}  
              if(res==IDOK){  
              RefreshRates();        
              if(!OrderClose(tick,OrderLots(),Bid,spr,Red)){
                Print("  ",GetLastError());
              }else{PlaySound("expert.wav");}
              }
            }
          }          
      }            
    }      
    
  }
    Sleep(200);
    Comment("");
  }
  
  
  

return;}
//+------------------------------------------------------------------+

